/* -----------------------------------
   Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: LIBERA_CARD_PADRAO.SQL

Criao:
12/09/06 - Matheus Totte
------------------------------------ */

/* DELEO DA PROCEDURE */
IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LIBERA_CARD_PADRAO'
             AND TYPE   = 'P'
             AND U.UID  = O.UID
             AND U.NAME = USER)
   DROP PROCEDURE LIBERA_CARD_PADRAO
GO

/* CRIAO */
CREATE PROCEDURE LIBERA_CARD_PADRAO(
   @P_CDFILIAL   VARCHAR(04),
   @P_DTMESCARD  DATETIME   ,
   @P_CDOPERADOR VARCHAR(12),
   @P_NRLISTA    VARCHAR(10))
AS
   DECLARE @V_NRCARDAPIO    VARCHAR(20);
   DECLARE @V_NRCARDAGRE    VARCHAR(20);
   DECLARE @V_CARDESPEC     VARCHAR(01);
   /* VARIAVEIS - TABELA DE SERVICO */
   DECLARE @V_QTCOMESTISEG  DOUBLE PRECISION;
   DECLARE @V_QTCOMESTITER  DOUBLE PRECISION;
   DECLARE @V_QTCOMESTIQUA  DOUBLE PRECISION;
   DECLARE @V_QTCOMESTIQUI  DOUBLE PRECISION;
   DECLARE @V_QTCOMESTISEX  DOUBLE PRECISION;
   DECLARE @V_QTCOMESTISAB  DOUBLE PRECISION;
   DECLARE @V_QTCOMESTIDOM  DOUBLE PRECISION;
   DECLARE @V_QTCOMESTIFER  DOUBLE PRECISION;
   DECLARE @V_QTCLIESTISEG  DOUBLE PRECISION;
   DECLARE @V_QTCLIESTITER  DOUBLE PRECISION;
   DECLARE @V_QTCLIESTIQUA  DOUBLE PRECISION;
   DECLARE @V_QTCLIESTIQUI  DOUBLE PRECISION;
   DECLARE @V_QTCLIESTISEX  DOUBLE PRECISION;
   DECLARE @V_QTCLIESTISAB  DOUBLE PRECISION;
   DECLARE @V_QTCLIESTIDOM  DOUBLE PRECISION;
   DECLARE @V_QTCLIESTIFER  DOUBLE PRECISION;
   DECLARE @V_QTFUNESTISEG  DOUBLE PRECISION;
   DECLARE @V_QTFUNESTITER  DOUBLE PRECISION;
   DECLARE @V_QTFUNESTIQUA  DOUBLE PRECISION;
   DECLARE @V_QTFUNESTIQUI  DOUBLE PRECISION;
   DECLARE @V_QTFUNESTISEX  DOUBLE PRECISION;
   DECLARE @V_QTFUNESTISAB  DOUBLE PRECISION;
   DECLARE @V_QTFUNESTIDOM  DOUBLE PRECISION;
   DECLARE @V_QTFUNESTIFER  DOUBLE PRECISION;
   DECLARE @V_QTDOAESTISEG  DOUBLE PRECISION;
   DECLARE @V_QTDOAESTITER  DOUBLE PRECISION;
   DECLARE @V_QTDOAESTIQUA  DOUBLE PRECISION;
   DECLARE @V_QTDOAESTIQUI  DOUBLE PRECISION;
   DECLARE @V_QTDOAESTISEX  DOUBLE PRECISION;
   DECLARE @V_QTDOAESTISAB  DOUBLE PRECISION;
   DECLARE @V_QTDOAESTIDOM  DOUBLE PRECISION;
   DECLARE @V_QTDOAESTIFER  DOUBLE PRECISION;
   DECLARE @V_QTESTITURNO1  DOUBLE PRECISION;
   DECLARE @V_QTESTITURNO2  DOUBLE PRECISION;
   DECLARE @V_QTESTITURNO3  DOUBLE PRECISION;
   DECLARE @V_QTESTITURNO4  DOUBLE PRECISION;

   DECLARE @V_QTCOMESTICAR  DOUBLE PRECISION;
   DECLARE @V_QTCLIESTICAR  DOUBLE PRECISION;
   DECLARE @V_QTFUNESTICAR  DOUBLE PRECISION;
   DECLARE @V_QTDOAESTICAR  DOUBLE PRECISION;

   DECLARE @V_DTFERIFILI    DATETIME; /* DATA FERIADO */

   DECLARE @V_INCTURNO      INTEGER;
   DECLARE @V_CONTCARDAMES  INTEGER;

   DECLARE @V_IDCENTRAL     VARCHAR(01);

   DECLARE @V_IDUTCARDPADR  VARCHAR(01);
   DECLARE @V_IDCARDIAUTIL  VARCHAR(01);

   DECLARE @V_CDFILIALEXIST VARCHAR(04);
   DECLARE @V_NRCARDEXIST   VARCHAR(10);
   DECLARE @V_IDCARDPADR    VARCHAR(01);
   DECLARE @V_EXISTCONF     VARCHAR(04);
   DECLARE @V_EXISTCARDAPIO VARCHAR(04);

   /* VARIAVEIS PARA OS CURSORES */
   DECLARE @VC_SERVICO_CDSERVFILI    VARCHAR(05);
   DECLARE @VC_FILIAL_AGREG_CDFILIAL VARCHAR(04);
   DECLARE @VC_CARDADIA_NRCARDAPIO   VARCHAR(10);
   DECLARE @VC_CARDADIA_DTCARDAPIO   DATETIME;
   DECLARE @VC_AGREGADA_CDFILIAL     VARCHAR(04);
   DECLARE @VC_TURNO_QTCOMESTTDOM    DOUBLE PRECISION;
   DECLARE @VC_TURNO_QTCOMESTTSEG    DOUBLE PRECISION;
   DECLARE @VC_TURNO_QTCOMESTTTER    DOUBLE PRECISION;
   DECLARE @VC_TURNO_QTCOMESTTQUA    DOUBLE PRECISION;
   DECLARE @VC_TURNO_QTCOMESTTQUI    DOUBLE PRECISION;
   DECLARE @VC_TURNO_QTCOMESTTSEX    DOUBLE PRECISION;
   DECLARE @VC_TURNO_QTCOMESTTSAB    DOUBLE PRECISION;
   DECLARE @VC_TURNO_QTCOMESTTFER    DOUBLE PRECISION;

   DECLARE @V_TEMP VARCHAR(30);
BEGIN
   SELECT
      @V_IDUTCARDPADR = MAX(IDUTCARDPADR)
   FROM
      PARAMGERAL;

   IF (@V_IDUTCARDPADR = 'S') BEGIN
      SELECT
         @V_IDCENTRAL = MAX(IDFILCENTPME)
      FROM
         FILIAL
      WHERE
         (CDFILIAL = @P_CDFILIAL);

      IF (@V_IDCENTRAL <> 'S') BEGIN
         RETURN;
      END;

      DECLARE C_SERVICO CURSOR FOR
         SELECT CDLISTA AS CDSERVFILI
         FROM   LISTA
         WHERE (NRLISTA = @P_NRLISTA);
      OPEN C_SERVICO;
      FETCH NEXT FROM C_SERVICO INTO @VC_SERVICO_CDSERVFILI;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         /* GRAVAR A CONFIGURACAO DO SERVICO DAS FILIAIS AGREGADAS */
         DECLARE C_FILIAL_AGREG CURSOR FOR
            SELECT DISTINCT F.CDFILIAL
            FROM FILIAL F, SERVICO S, CONFCARD C
            WHERE (F.CDFILCENTPME = @P_CDFILIAL           ) AND
                  (S.CDFILIAL     = F.CDFILIAL            ) AND
                  (S.CDSERVFILI   = @VC_SERVICO_CDSERVFILI) AND
                  (C.CDFILIAL     = S.CDFILIAL            ) AND
                  (C.CDSERVFILI   = S.CDSERVFILI          );
         OPEN C_FILIAL_AGREG;
         FETCH NEXT FROM C_FILIAL_AGREG INTO @VC_FILIAL_AGREG_CDFILIAL;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT
               @V_EXISTCONF = MAX(CDFILIAL)
            FROM CNFCAMES
            WHERE
               (CDFILIAL     = @VC_FILIAL_AGREG_CDFILIAL) AND
               (CDSERVFILI   = @VC_SERVICO_CDSERVFILI   ) AND
               (DTREFECNFMES = @P_DTMESCARD             );

            IF (@V_EXISTCONF IS NULL) BEGIN
                  
               INSERT INTO CNFCAMES (
                      CDFILIAL,     CDSERVFILI,   NRSEQCNFMES,
                      DTREFECNFMES, CDTIPOPRAT,   IDOPCCNFMES,
                      IDIMPCNFMES,  NRPAGCNFMES,  VRPERCOMMES,
                      NRORDCNFMES,  DSCOMPLTPMES, IDCONCNFMES,
                      IDTPPRATDOMM, IDTPPRATSEGM, IDTPPRATTERM,
                      IDTPPRATQUAM, IDTPPRATQUIM, IDTPPRATSEXM,
                      IDTPPRATSABM, IDTPPRATFERM)
               SELECT @VC_FILIAL_AGREG_CDFILIAL, @VC_SERVICO_CDSERVFILI, NRSEQCNFCARD,
                      @P_DTMESCARD,              CDTIPOPRAT,             IDOPCCNFCARD,
                      IDIMPCNFCARD, NRPAGCNFCARD, VRPERCOMCARD,
                      NRORDCNFCARD, DSCOMPLTP, IDCONCNFCARD,
                      ISNULL(IDTPPRATDOMP, 'S'), ISNULL(IDTPPRATSEGP, 'S'), ISNULL(IDTPPRATTERP, 'S'),
                      ISNULL(IDTPPRATQUAP, 'S'), ISNULL(IDTPPRATQUIP, 'S'), ISNULL(IDTPPRATSEXP, 'S'),
                      ISNULL(IDTPPRATSABP, 'S'), ISNULL(IDTPPRATFERP, 'S')
               FROM   CONFCARD
               WHERE (CDFILIAL     = @VC_FILIAL_AGREG_CDFILIAL) AND
                     (CDSERVFILI   = @VC_SERVICO_CDSERVFILI   ) AND
                     (IDVISUTPEXTR = 'S'                      );
            END;

            FETCH NEXT FROM C_FILIAL_AGREG INTO @VC_FILIAL_AGREG_CDFILIAL;
         END;
         CLOSE C_FILIAL_AGREG;
         DEALLOCATE C_FILIAL_AGREG;
         /**/
         
         /* LER O CARDAPIO PADRAO */
         DECLARE C_CARDADIA CURSOR FOR
            SELECT C.NRCARDAPIO, C.DTCARDAPIO
            FROM  CARDADIA C LEFT OUTER JOIN CARDAMES CM ON
                  (C.CDFILIAL   = CM.CDFILIAL           ) AND
                  (C.CDSERVFILI = CM.CDSERVFILI         ) AND
                  (C.DTMESCARD  = CM.DTMESCARDAPIO      )
            WHERE (C.CDFILIAL   = @P_CDFILIAL           ) AND
                  (C.CDSERVFILI = @VC_SERVICO_CDSERVFILI) AND
                  (C.DTMESCARD  = @P_DTMESCARD          ) AND
                  (ISNULL(CM.IDCARDLIBCENT, 'N') = 'N');
         OPEN C_CARDADIA;
         
         FETCH NEXT FROM C_CARDADIA INTO @VC_CARDADIA_NRCARDAPIO,
                                         @VC_CARDADIA_DTCARDAPIO;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            DECLARE C_AGREGADA CURSOR FOR
               SELECT DISTINCT F.CDFILIAL
               FROM  FILIAL F, SERVICO S, CONFCARD C
               WHERE (F.CDFILCENTPME = @P_CDFILIAL           ) AND
                     (S.CDFILIAL     = F.CDFILIAL            ) AND
                     (S.CDSERVFILI   = @VC_SERVICO_CDSERVFILI) AND
                     (C.CDFILIAL     = S.CDFILIAL            ) AND
                     (C.CDSERVFILI   = S.CDSERVFILI          );
            OPEN C_AGREGADA;
            FETCH NEXT FROM C_AGREGADA INTO @VC_AGREGADA_CDFILIAL;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT
                  @V_DTFERIFILI = MAX(DTFERIFILI)
               FROM
                  FERIFILI
               WHERE
                  (CDFILIAL   = @VC_AGREGADA_CDFILIAL  ) AND
                  (DTFERIFILI = @VC_CARDADIA_DTCARDAPIO);

               SELECT
                  @V_IDCARDIAUTIL = MAX(IDCARDIAUTIL)
               FROM  PARAMPLANEJA
               WHERE (CDFILIAL = @VC_AGREGADA_CDFILIAL);

               IF NOT ((@V_DTFERIFILI IS NOT NULL) AND (@V_IDCARDIAUTIL = 'S')) BEGIN
                  SELECT
                     @V_QTCOMESTISEG = SUM(QTCOMESTISEG),
                     @V_QTCOMESTITER = SUM(QTCOMESTITER),
                     @V_QTCOMESTIQUA = SUM(QTCOMESTIQUA),
                     @V_QTCOMESTIQUI = SUM(QTCOMESTIQUI),
                     @V_QTCOMESTISEX = SUM(QTCOMESTISEX),
                     @V_QTCOMESTISAB = SUM(QTCOMESTISAB),
                     @V_QTCOMESTIDOM = SUM(QTCOMESTIDOM),
                     @V_QTCOMESTIFER = SUM(QTCOMESTIFER),
                     @V_QTCLIESTISEG = SUM(QTCLIESTISEG),
                     @V_QTCLIESTITER = SUM(QTCLIESTITER),
                     @V_QTCLIESTIQUA = SUM(QTCLIESTIQUA),
                     @V_QTCLIESTIQUI = SUM(QTCLIESTIQUI),
                     @V_QTCLIESTISEX = SUM(QTCLIESTISEX),
                     @V_QTCLIESTISAB = SUM(QTCLIESTISAB),
                     @V_QTCLIESTIDOM = SUM(QTCLIESTIDOM),
                     @V_QTCLIESTIFER = SUM(QTCLIESTIFER),
                     @V_QTFUNESTISEG = SUM(QTFUNESTISEG),
                     @V_QTFUNESTITER = SUM(QTFUNESTITER),
                     @V_QTFUNESTIQUA = SUM(QTFUNESTIQUA),
                     @V_QTFUNESTIQUI = SUM(QTFUNESTIQUI),
                     @V_QTFUNESTISEX = SUM(QTFUNESTISEX),
                     @V_QTFUNESTISAB = SUM(QTFUNESTISAB),
                     @V_QTFUNESTIDOM = SUM(QTFUNESTIDOM),
                     @V_QTFUNESTIFER = SUM(QTFUNESTIFER),
                     @V_QTDOAESTISEG = SUM(QTDOAESTISEG),
                     @V_QTDOAESTITER = SUM(QTDOAESTITER),
                     @V_QTDOAESTIQUA = SUM(QTDOAESTIQUA),
                     @V_QTDOAESTIQUI = SUM(QTDOAESTIQUI),
                     @V_QTDOAESTISEX = SUM(QTDOAESTISEX),
                     @V_QTDOAESTISAB = SUM(QTDOAESTISAB),
                     @V_QTDOAESTIDOM = SUM(QTDOAESTIDOM),
                     @V_QTDOAESTIFER = SUM(QTDOAESTIFER)
                  FROM
                     SERVICO
                  WHERE
                     (CDFILIAL   = @VC_AGREGADA_CDFILIAL ) AND
                     (CDSERVFILI = @VC_SERVICO_CDSERVFILI)
                  GROUP BY
                     CDFILIAL, CDSERVFILI;

                  IF (@V_DTFERIFILI IS NULL) BEGIN
                     SELECT
                        
                        @V_DTFERIFILI = MAX(DTFERICARD)
                     FROM
                        FERICARD
                     WHERE
                        (CDFILIAL   = @VC_AGREGADA_CDFILIAL) AND
                        (DTFERICARD = @VC_CARDADIA_DTCARDAPIO);
                  END

                  IF (@V_DTFERIFILI IS NOT NULL) BEGIN
                      /* Grava comensais para Feriado */
                     SET @V_QTCOMESTICAR = @V_QTCOMESTIFER;
                     SET @V_QTCLIESTICAR = @V_QTCLIESTIFER;
                     SET @V_QTFUNESTICAR = @V_QTFUNESTIFER;
                     SET @V_QTDOAESTICAR = @V_QTDOAESTIFER;
                  END
                  ELSE BEGIN
                     /* Grava comensais para os dias da semana (no-feriados) */
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '1' BEGIN
                        SET @V_QTCOMESTICAR = @V_QTCOMESTIDOM;
                        SET @V_QTCLIESTICAR = @V_QTCLIESTIDOM;
                        SET @V_QTFUNESTICAR = @V_QTFUNESTIDOM;
                        SET @V_QTDOAESTICAR = @V_QTDOAESTIDOM;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '2' BEGIN
                        SET @V_QTCOMESTICAR = @V_QTCOMESTISEG;
                        SET @V_QTCLIESTICAR = @V_QTCLIESTISEG;
                        SET @V_QTFUNESTICAR = @V_QTFUNESTISEG;
                        SET @V_QTDOAESTICAR = @V_QTDOAESTISEG;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '3' BEGIN
                        SET @V_QTCOMESTICAR = @V_QTCOMESTITER;
                        SET @V_QTCLIESTICAR = @V_QTCLIESTITER;
                        SET @V_QTFUNESTICAR = @V_QTFUNESTITER;
                        SET @V_QTDOAESTICAR = @V_QTDOAESTITER;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '4' BEGIN
                        SET @V_QTCOMESTICAR = @V_QTCOMESTIQUA;
                        SET @V_QTCLIESTICAR = @V_QTCLIESTIQUA;
                        SET @V_QTFUNESTICAR = @V_QTFUNESTIQUA;
                        SET @V_QTDOAESTICAR = @V_QTDOAESTIQUA;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '5' BEGIN
                        SET @V_QTCOMESTICAR = @V_QTCOMESTIQUI;
                        SET @V_QTCLIESTICAR = @V_QTCLIESTIQUI;
                        SET @V_QTFUNESTICAR = @V_QTFUNESTIQUI;
                        SET @V_QTDOAESTICAR = @V_QTDOAESTIQUI;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '6' BEGIN
                        SET @V_QTCOMESTICAR = @V_QTCOMESTISEX;
                        SET @V_QTCLIESTICAR = @V_QTCLIESTISEX;
                        SET @V_QTFUNESTICAR = @V_QTFUNESTISEX;
                        SET @V_QTDOAESTICAR = @V_QTDOAESTISEX;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '7' BEGIN
                        SET @V_QTCOMESTICAR = @V_QTCOMESTISAB;
                        SET @V_QTCLIESTICAR = @V_QTCLIESTISAB;
                        SET @V_QTFUNESTICAR = @V_QTFUNESTISAB;
                        SET @V_QTDOAESTICAR = @V_QTDOAESTISAB;
                     END;
                  END;

                  SET @V_INCTURNO = 1;

                  DECLARE C_TURNO CURSOR FOR
                     SELECT
                        QTCOMESTTDOM, QTCOMESTTSEG, QTCOMESTTTER,
                        QTCOMESTTQUA, QTCOMESTTQUI, QTCOMESTTSEX,
                        QTCOMESTTSAB, QTCOMESTTFER
                     FROM TURNOSERV
                     WHERE
                        (CDFILIAL   = @VC_AGREGADA_CDFILIAL ) AND
                        (CDSERVFILI = @VC_SERVICO_CDSERVFILI)
                     ORDER BY CDTURNO;
                  OPEN C_TURNO;
                  FETCH NEXT FROM C_TURNO INTO @VC_TURNO_QTCOMESTTDOM,
                                               @VC_TURNO_QTCOMESTTSEG,
                                               @VC_TURNO_QTCOMESTTTER,
                                               @VC_TURNO_QTCOMESTTQUA,
                                               @VC_TURNO_QTCOMESTTQUI,
                                               @VC_TURNO_QTCOMESTTSEX,
                                               @VC_TURNO_QTCOMESTTSAB,
                                               @VC_TURNO_QTCOMESTTFER;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '1' BEGIN
                        IF @V_INCTURNO = 1 BEGIN
                           SET @V_QTESTITURNO1 = @VC_TURNO_QTCOMESTTDOM;
                        END;
                        IF @V_INCTURNO = 2 BEGIN
                           SET @V_QTESTITURNO2 = @VC_TURNO_QTCOMESTTDOM;
                        END;
                        IF @V_INCTURNO = 3 BEGIN
                           SET @V_QTESTITURNO3 = @VC_TURNO_QTCOMESTTDOM;
                        END;
                        IF @V_INCTURNO = 4 BEGIN
                           SET @V_QTESTITURNO4 = @VC_TURNO_QTCOMESTTDOM;
                        END;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '2' BEGIN
                        IF @V_INCTURNO = 1 BEGIN
                           SET @V_QTESTITURNO1 = @VC_TURNO_QTCOMESTTSEG;
                        END;
                        IF @V_INCTURNO = 2 BEGIN
                           SET @V_QTESTITURNO2 = @VC_TURNO_QTCOMESTTSEG;
                        END;
                        IF @V_INCTURNO = 3 BEGIN
                           SET @V_QTESTITURNO3 = @VC_TURNO_QTCOMESTTSEG;
                        END;
                        IF @V_INCTURNO = 4 BEGIN
                           SET @V_QTESTITURNO4 = @VC_TURNO_QTCOMESTTSEG;
                        END;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '3' BEGIN
                        IF @V_INCTURNO = 1 BEGIN
                           SET @V_QTESTITURNO1 = @VC_TURNO_QTCOMESTTTER;
                        END;
                        IF @V_INCTURNO = 2 BEGIN
                           SET @V_QTESTITURNO2 = @VC_TURNO_QTCOMESTTTER;
                        END;
                        IF @V_INCTURNO = 3 BEGIN
                           SET @V_QTESTITURNO3 = @VC_TURNO_QTCOMESTTTER;
                        END;
                        IF @V_INCTURNO = 4 BEGIN
                           SET @V_QTESTITURNO4 = @VC_TURNO_QTCOMESTTTER;
                        END;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '4' BEGIN
                        IF @V_INCTURNO = 1 BEGIN
                           SET @V_QTESTITURNO1 = @VC_TURNO_QTCOMESTTQUA;
                        END;
                        IF @V_INCTURNO = 2 BEGIN
                           SET @V_QTESTITURNO2 = @VC_TURNO_QTCOMESTTQUA;
                        END;
                        IF @V_INCTURNO = 3 BEGIN
                           SET @V_QTESTITURNO3 = @VC_TURNO_QTCOMESTTQUA;
                        END;
                        IF @V_INCTURNO = 4 BEGIN
                           SET @V_QTESTITURNO4 = @VC_TURNO_QTCOMESTTQUA;
                        END;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '5' BEGIN
                        IF @V_INCTURNO = 1 BEGIN
                           SET @V_QTESTITURNO1 = @VC_TURNO_QTCOMESTTQUI;
                        END;
                        IF @V_INCTURNO = 2 BEGIN
                           SET @V_QTESTITURNO2 = @VC_TURNO_QTCOMESTTQUI;
                        END;
                        IF @V_INCTURNO = 3 BEGIN
                           SET @V_QTESTITURNO3 = @VC_TURNO_QTCOMESTTQUI;
                        END
                        IF @V_INCTURNO = 4 BEGIN
                           SET @V_QTESTITURNO4 = @VC_TURNO_QTCOMESTTQUI;
                        END;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '6' BEGIN
                        IF @V_INCTURNO = 1 BEGIN
                           SET @V_QTESTITURNO1 = @VC_TURNO_QTCOMESTTSEX;
                        END;
                        IF @V_INCTURNO = 2 BEGIN
                           SET @V_QTESTITURNO2 = @VC_TURNO_QTCOMESTTSEX;
                        END;
                        IF @V_INCTURNO = 3 BEGIN
                           SET @V_QTESTITURNO3 = @VC_TURNO_QTCOMESTTSEX;
                        END;
                        IF @V_INCTURNO = 4 BEGIN
                           SET @V_QTESTITURNO4 = @VC_TURNO_QTCOMESTTSEX;
                        END;
                     END;
                     IF CONVERT(VARCHAR, DATEPART(W,@VC_CARDADIA_DTCARDAPIO)) = '7' BEGIN
                        IF @V_INCTURNO = 1 BEGIN
                           SET @V_QTESTITURNO1 = @VC_TURNO_QTCOMESTTSAB;
                        END;
                        IF @V_INCTURNO = 2 BEGIN
                           SET @V_QTESTITURNO2 = @VC_TURNO_QTCOMESTTSAB;
                        END;
                        IF @V_INCTURNO = 3 BEGIN
                           SET @V_QTESTITURNO3 = @VC_TURNO_QTCOMESTTSAB;
                        END;
                        IF @V_INCTURNO = 4 BEGIN
                           SET @V_QTESTITURNO4 = @VC_TURNO_QTCOMESTTSAB;
                        END;
                     END;

                     IF (@V_DTFERIFILI IS NOT NULL) BEGIN
                        IF @V_INCTURNO = 1 BEGIN
                           SET @V_QTESTITURNO1 = @VC_TURNO_QTCOMESTTFER;
                        END;
                        IF @V_INCTURNO = 2 BEGIN
                           SET @V_QTESTITURNO2 = @VC_TURNO_QTCOMESTTFER;
                        END;
                        IF @V_INCTURNO = 3 BEGIN
                           SET @V_QTESTITURNO3 = @VC_TURNO_QTCOMESTTFER;
                        END;
                        IF @V_INCTURNO = 4 BEGIN
                           SET @V_QTESTITURNO4 = @VC_TURNO_QTCOMESTTFER;
                        END;
                     END;

                     SET @V_INCTURNO = @V_INCTURNO + 1;

                     FETCH NEXT FROM C_TURNO INTO @VC_TURNO_QTCOMESTTDOM,
                                                  @VC_TURNO_QTCOMESTTSEG,
                                                  @VC_TURNO_QTCOMESTTTER,
                                                  @VC_TURNO_QTCOMESTTQUA,
                                                  @VC_TURNO_QTCOMESTTQUI,
                                                  @VC_TURNO_QTCOMESTTSEX,
                                                  @VC_TURNO_QTCOMESTTSAB,
                                                  @VC_TURNO_QTCOMESTTFER;
                  END;
                  CLOSE C_TURNO;
                  DEALLOCATE C_TURNO;

                  SELECT
                     @V_EXISTCARDAPIO = MAX(CDFILIAL),
                     @V_NRCARDAGRE    = MAX(NRCARDAPIO),
                     @V_CARDESPEC     = MAX(IDCARDIAESPE)
                  FROM  CARDADIA
                  WHERE (CDFILIAL   = @VC_AGREGADA_CDFILIAL  ) AND
                        (CDSERVFILI = @VC_SERVICO_CDSERVFILI ) AND
                        (DTCARDAPIO = @VC_CARDADIA_DTCARDAPIO);

                  /*Exclui cardpio no especfico caso o mesmo seja liberado mais de uma vez*/
                  IF (@V_EXISTCARDAPIO IS NOT NULL) AND ((@V_CARDESPEC IS NULL) OR (@V_CARDESPEC = 'N')) BEGIN
                     DELETE FROM COMPCARD
                     WHERE (CDFILIAL   = @VC_AGREGADA_CDFILIAL) AND
                           (NRCARDAPIO = @V_NRCARDAGRE        );

                     DELETE FROM CARDADIA
                     WHERE (CDFILIAL   = @VC_AGREGADA_CDFILIAL) AND
                           (NRCARDAPIO = @V_NRCARDAGRE        );

                     SET @V_EXISTCARDAPIO = NULL;
                  END;
                  /***************************************************************************/

                  IF (@V_EXISTCARDAPIO  IS NULL) BEGIN
                     SET @V_TEMP = 'CARDAPIO'+@VC_AGREGADA_CDFILIAL;
                     EXEC NOVO_CODIGO_SC @V_TEMP, @V_NRCARDAPIO OUTPUT, 1;
                     SET @V_NRCARDAPIO = SUBSTRING(@V_NRCARDAPIO, 11, 10);

                        IF (@V_QTCOMESTICAR > 0) BEGIN
                            INSERT INTO CARDADIA (
                            CDFILIAL,     NRCARDAPIO,   CDSERVFILI,
                            CDOPERADOR,   DTCARDAPIO,   DTMESCARD,
                            QTCOMESTICAR, QTESTITURNO1, QTESTITURNO2,
                            QTESTITURNO3, QTESTITURNO4, QTCLIESTICAR,
                            QTFUNESTICAR, QTDOAESTICAR)
                            VALUES(@VC_AGREGADA_CDFILIAL,
                            SUBSTRING(@V_NRCARDAPIO, 1, 10),
                            @VC_SERVICO_CDSERVFILI,
                            @P_CDOPERADOR,
                            @VC_CARDADIA_DTCARDAPIO,
                            @P_DTMESCARD,
                            @V_QTCOMESTICAR,
                            @V_QTESTITURNO1,
                            @V_QTESTITURNO2,
                            @V_QTESTITURNO3,
                            @V_QTESTITURNO4,
                            @V_QTCLIESTICAR,
                            @V_QTFUNESTICAR,
                            @V_QTDOAESTICAR);

                     INSERT INTO COMPCARD (
                            CDFILIAL,     NRCARDAPIO, NRSEQPRATCAR,
                            CDFILAUXPRAT, CDPRATO,    VRPECONSCARD,
                            QTSOBRLIMPPR, CDTIPOPRAT, QTCOMEFETPRA,
                            QTPRODUZPRAT, NRORDPRATCAR)
                     SELECT @VC_AGREGADA_CDFILIAL, SUBSTRING(@V_NRCARDAPIO, 1, 10), P.NRSEQPRATCAR,
                            PRA.CDFILAUXPRAT, P.CDPRATO, P.VRPECONSCARD + ISNULL(ACRESCENTAR.VALOR, 0),
                            P.QTSOBRLIMPPR, P.CDTIPOPRAT, P.QTCOMEFETPRA,
                            P.QTPRODUZPRAT, P.NRORDPRATCAR
                     FROM  CARDADIA C, CNFCAMES F, PRATO PRC, PRATO PRA,
                           COMPCARD P LEFT JOIN (SELECT A.CDTIPOPRAT, CASE QT.QTTIPOPRATOS WHEN 0 THEN 0 ELSE A.SOMAPERC / QT.QTTIPOPRATOS END AS VALOR
                                                 FROM (SELECT CC.CDTIPOPRAT,
                                                              SUM(CC.VRPECONSCARD) AS SOMAPERC
                                                       FROM   CARDADIA C, COMPCARD CC
                                                       WHERE  C.CDFILIAL    = @P_CDFILIAL             AND
                                                              C.NRCARDAPIO  = @VC_CARDADIA_NRCARDAPIO AND
                                                              CC.CDFILIAL   = C.CDFILIAL              AND
                                                              CC.NRCARDAPIO = C.NRCARDAPIO            AND
                                                              NOT EXISTS (SELECT CF.CDTIPOPRAT
                                                                          FROM   CNFCAMES CF
                                                                          WHERE  CF.CDFILIAL     = @VC_AGREGADA_CDFILIAL  AND
                                                                                 CF.CDSERVFILI   = @VC_SERVICO_CDSERVFILI AND
                                                                                 CF.DTREFECNFMES = @P_DTMESCARD           AND
                                                                                 CF.NRSEQCNFMES  = CC.NRSEQPRATCAR        AND
                                                                                 'S' = CASE WHEN DATEPART(DW, @V_DTFERIFILI) IS NULL THEN
                                                                                             CASE DATEPART(DW, C.DTCARDAPIO)
                                                                                                WHEN 1 THEN CF.IDTPPRATDOMM
                                                                                                WHEN 2 THEN CF.IDTPPRATSEGM
                                                                                                WHEN 3 THEN CF.IDTPPRATTERM
                                                                                                WHEN 4 THEN CF.IDTPPRATQUAM
                                                                                                WHEN 5 THEN CF.IDTPPRATQUIM
                                                                                                WHEN 6 THEN CF.IDTPPRATSEXM
                                                                                                WHEN 7 THEN CF.IDTPPRATSABM
                                                                                             END
                                                                                          ELSE CF.IDTPPRATFERM
                                                                                       END)
                                                       GROUP BY CC.CDTIPOPRAT) A,
                                                      (SELECT CF.CDTIPOPRAT,
                                                              COUNT(CF.CDTIPOPRAT) AS QTTIPOPRATOS
                                                       FROM   CARDADIA C,
                                                              CNFCAMES CF
                                                       WHERE  C.CDFILIAL   = @VC_AGREGADA_CDFILIAL  AND
                                                              C.NRCARDAPIO = SUBSTRING(@V_NRCARDAPIO, 1, 10) AND
                                                              C.CDFILIAL   = CF.CDFILIAL     AND
                                                              C.CDSERVFILI = CF.CDSERVFILI   AND
                                                              C.DTMESCARD  = CF.DTREFECNFMES AND
                                                              'S' = CASE WHEN DATEPART(DW, @V_DTFERIFILI) IS NULL THEN
                                                                          CASE DATEPART(DW, C.DTCARDAPIO)
                                                                             WHEN 1 THEN CF.IDTPPRATDOMM
                                                                             WHEN 2 THEN CF.IDTPPRATSEGM
                                                                             WHEN 3 THEN CF.IDTPPRATTERM
                                                                             WHEN 4 THEN CF.IDTPPRATQUAM
                                                                             WHEN 5 THEN CF.IDTPPRATQUIM
                                                                             WHEN 6 THEN CF.IDTPPRATSEXM
                                                                             WHEN 7 THEN CF.IDTPPRATSABM
                                                                          END
                                                                       ELSE CF.IDTPPRATFERM
                                                                    END
                                                       GROUP BY CF.CDTIPOPRAT) QT
                                                 WHERE A.CDTIPOPRAT = QT.CDTIPOPRAT) ACRESCENTAR ON
                                           P.CDTIPOPRAT = ACRESCENTAR.CDTIPOPRAT
                     WHERE (C.CDFILIAL     = @P_CDFILIAL            ) AND
                           (C.NRCARDAPIO   = @VC_CARDADIA_NRCARDAPIO) AND
                           (P.CDFILIAL     = C.CDFILIAL             ) AND
                           (P.NRCARDAPIO   = C.NRCARDAPIO           ) AND
                           (F.CDFILIAL     = @VC_AGREGADA_CDFILIAL  ) AND
                           (F.CDSERVFILI   = @VC_SERVICO_CDSERVFILI ) AND
                           (F.NRSEQCNFMES  = P.NRSEQPRATCAR         ) AND
                           (F.DTREFECNFMES = @P_DTMESCARD           ) AND
                           (F.CDTIPOPRAT   = P.CDTIPOPRAT           ) AND
                           (pra.cdprato = p.cdprato) and
                           (pra.cdfilauxprat in ('P', @VC_AGREGADA_CDFILIAL)) and
                           (prc.cdprato = p.cdprato) and
                           (prc.cdfilauxprat in ('P', @P_CDFILIAL)) and
                           (prc.nmprato = pra.nmprato) and
                           ('S' = CASE WHEN DATEPART(DW, @V_DTFERIFILI) IS NULL THEN
                                        CASE DATEPART(DW, C.DTCARDAPIO)
                                           WHEN 1 THEN F.IDTPPRATDOMM
                                           WHEN 2 THEN F.IDTPPRATSEGM
                                           WHEN 3 THEN F.IDTPPRATTERM
                                           WHEN 4 THEN F.IDTPPRATQUAM
                                           WHEN 5 THEN F.IDTPPRATQUIM
                                           WHEN 6 THEN F.IDTPPRATSEXM
                                           WHEN 7 THEN F.IDTPPRATSABM
                                        END
                                     ELSE F.IDTPPRATFERM
                                  END);
                        END;
                  END;
               END;

               FETCH NEXT FROM C_AGREGADA INTO @VC_AGREGADA_CDFILIAL;
            END;
            CLOSE C_AGREGADA;
            DEALLOCATE C_AGREGADA;

            FETCH NEXT FROM C_CARDADIA INTO @VC_CARDADIA_NRCARDAPIO,
                                            @VC_CARDADIA_DTCARDAPIO;
         END;
         CLOSE C_CARDADIA;
         DEALLOCATE C_CARDADIA;

         FETCH NEXT FROM C_SERVICO INTO @VC_SERVICO_CDSERVFILI;
      END;
      CLOSE C_SERVICO;
      DEALLOCATE C_SERVICO;
   END;

   DECLARE C_SERVICO CURSOR FOR
   SELECT CDLISTA AS CDSERVFILI
   FROM LISTA
   WHERE (NRLISTA = @P_NRLISTA);

   OPEN C_SERVICO;
   FETCH NEXT FROM C_SERVICO INTO @VC_SERVICO_CDSERVFILI;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      /*Select criado para verificar se existe o registro na tabela CARDAMES. Caso exista,
        edita o registro informando a data de referncia. Caso contrrio, insere o registro na tabela.*/
      SELECT @V_CONTCARDAMES = COUNT(*)
      FROM CARDAMES
      WHERE (CDFILIAL      = @P_CDFILIAL           )
        AND (CDSERVFILI    = @VC_SERVICO_CDSERVFILI)
        AND (DTMESCARDAPIO = @P_DTMESCARD          );

      IF @V_CONTCARDAMES > 0 BEGIN
         UPDATE CARDAMES
         SET DTREFECUSTMES = CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)), IDCARDLIBCENT = 'S'
         WHERE (CDFILIAL      = @P_CDFILIAL           )
           AND (CDSERVFILI    = @VC_SERVICO_CDSERVFILI)
           AND (DTMESCARDAPIO = @P_DTMESCARD          );
      END ELSE BEGIN
         INSERT INTO CARDAMES
            (CDFILIAL, CDSERVFILI, DTMESCARDAPIO, DTREFECUSTMES, IDCARDLIBCENT)
         VALUES
            (@P_CDFILIAL, @VC_SERVICO_CDSERVFILI, @P_DTMESCARD, CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)),  'S');
      END;

      FETCH NEXT FROM C_SERVICO INTO @VC_SERVICO_CDSERVFILI;
   END;
   CLOSE C_SERVICO;
   DEALLOCATE C_SERVICO;

   DELETE FROM CTRLAPROVCARD
   WHERE
      (CDFILIAL        = @P_CDFILIAL   ) AND
      (DTMESCARDAPROV  = @P_DTMESCARD  ) AND
      EXISTS
         (SELECT CDFILIAL
             FROM LISTA
             WHERE (CDSERVFILI = CDLISTA    ) AND
                   (NRLISTA    = @P_NRLISTA ) );

   INSERT INTO CTRLAPROVCARD
      (CDFILIAL, CDSERVFILI, DTMESCARDAPROV, DTLIBECARDMATR, CDOPERAPROCARDFILI)
   SELECT
      @P_CDFILIAL, CDLISTA, @P_DTMESCARD, CONVERT(DATETIME, CONVERT(VARCHAR,GETDATE(),103)), @P_CDOPERADOR
   FROM
     LISTA L
   WHERE
     (L.NRLISTA    = @P_NRLISTA  );

   DELETE FROM LISTA
   WHERE  NRLISTA = @P_NRLISTA;

   /*COMMIT;*/
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LIBERA_CARD_PADRAO','5.03.006';
GO

